searchNodes=[{"doc":"Represents a Wasm instance powered by Wasmtime. The module can be loaded via bytes or a file path. Wasmtime will JIT compile, interpret and make it available. This Elixir module is backed by a GenServer for concurrency reasons and to keep state of the loaded instance.","ref":"Wasmtime.html","title":"Wasmtime","type":"module"},{"doc":"Call a Wasm function.","ref":"Wasmtime.html#call_func/3","title":"Wasmtime.call_func/3","type":"function"},{"doc":"Call a Wasm function without using threads for specific low latency use cases. This function should only be used if you really have to save some extra microseconds, and the Wasm function is lightweight (takes less than &lt; 1ms to execute). Also, the Wasm module can't have any imports when using this function.","ref":"Wasmtime.html#call_func_xt/3","title":"Wasmtime.call_func_xt/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Wasmtime.html#child_spec/1","title":"Wasmtime.child_spec/1","type":"function"},{"doc":"List all Wasm types exported.","ref":"Wasmtime.html#exports/1","title":"Wasmtime.exports/1","type":"function"},{"doc":"Get an exported Wasm function.","ref":"Wasmtime.html#get_func/2","title":"Wasmtime.get_func/2","type":"function"},{"doc":"Load a Wasm module given bytes in memory or from a Wasm file. Both .wasm and .wat files are supported.iex&gt; {:ok, _pid} = Wasmtime.load(%Wasmtime.FromFile{file_path: &quot;test/data/adder.wat&quot;})","ref":"Wasmtime.html#load/1","title":"Wasmtime.load/1","type":"function"},{"doc":"Struct for configuring Wasmtime options.","ref":"Wasmtime.Config.html","title":"Wasmtime.Config","type":"module"},{"doc":"Wasmtime.Config","ref":"Wasmtime.Config.html#t:t/0","title":"Wasmtime.Config.t/0","type":"type"},{"doc":"A struct representing a Wasm instance from a bytes payload.","ref":"Wasmtime.FromBytes.html","title":"Wasmtime.FromBytes","type":"module"},{"doc":"Wasmtime.FromBytes","ref":"Wasmtime.FromBytes.html#t:t/0","title":"Wasmtime.FromBytes.t/0","type":"type"},{"doc":"A struct representing a Wasm instance from a file. Both .wasm and .wat files can be interpreted by wasmtime.","ref":"Wasmtime.FromFile.html","title":"Wasmtime.FromFile","type":"module"},{"doc":"Wasmtime.FromFile","ref":"Wasmtime.FromFile.html#t:t/0","title":"Wasmtime.FromFile.t/0","type":"type"},{"doc":"Wasmtime NIFs. These functions aren't meant to be accessed directly by application code. The Wasmtime module expose them through a GenServer.","ref":"Wasmtime.Native.html","title":"Wasmtime.Native","type":"module"},{"doc":"","ref":"Wasmtime.Native.html#call_func/6","title":"Wasmtime.Native.call_func/6","type":"function"},{"doc":"","ref":"Wasmtime.Native.html#call_func_xt/3","title":"Wasmtime.Native.call_func_xt/3","type":"function"},{"doc":"","ref":"Wasmtime.Native.html#exfn_reply/3","title":"Wasmtime.Native.exfn_reply/3","type":"function"},{"doc":"","ref":"Wasmtime.Native.html#exports/2","title":"Wasmtime.Native.exports/2","type":"function"},{"doc":"","ref":"Wasmtime.Native.html#get_func/3","title":"Wasmtime.Native.get_func/3","type":"function"},{"doc":"","ref":"Wasmtime.Native.html#load_from/7","title":"Wasmtime.Native.load_from/7","type":"function"},{"doc":"&lt;h1&gt;&lt;code&gt;wasmtime-ex&lt;/code&gt;&lt;/h1&gt; &lt;strong&gt;💧Elixir WebAssembly runtime powered by &lt;a href=&quot;https://github.com/bytecodealliance/wasmtime&quot;&gt;Wasmtime 🦀&lt;/a&gt;&lt;/strong&gt; &lt;p&gt;&lt;/p&gt; &lt;p&gt; &lt;a href=&quot;https://github.com/viniarck/wasmtime-ex/workflows/.github/workflows/tests.yml/badge.svg&quot;&gt;&lt;img src=&quot;https://github.com/viniarck/wasmtime-ex/workflows/.github/workflows/tests.yml/badge.svg&quot; alt=&quot;tests&quot; /&gt;&lt;/a&gt; &lt;a href=&quot;https://img.shields.io/hexpm/v/wasmtime.svg&quot;&gt;&lt;img src=&quot;https://img.shields.io/hexpm/v/wasmtime.svg&quot; alt=&quot;hex.pm version&quot; /&gt;&lt;/a&gt; &lt;a href=&quot;https://img.shields.io/hexpm/v/wasmtime.svg&quot;&gt;&lt;img src=&quot;https://img.shields.io/hexpm/dt/wasmtime.svg&quot; alt=&quot;hex.pm downloads&quot; /&gt;&lt;/a&gt; &lt;/p&gt; &lt;h3&gt; &lt;a href=&quot;https://hexdocs.pm/wasmtime&quot;&gt;Docs&lt;/a&gt; &lt;/h3&gt; &lt;!-- this html was based on https://github.com/bytecodealliance/wasmtime --&gt;","ref":"readme.html","title":"README","type":"extras"},{"doc":"You can add wasmtime to your list of dependencies in mix.exs:def deps do [ {:wasmtime, &quot;~&gt; 0.2.0&quot;} ] endThis package is still under heavy development, I'd recommend you to wait for the 0.2.0 release since the core API might still change, feel free to explore it in the meantime. Enjoy!","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"In this example, the Wasm module is compiled, instantiated and a host function is called and imported from Elixir:mod = ~S/ (module (import &quot;&quot; &quot;&quot; (func $compute (param i32) (result i32))) (func (export &quot;run&quot;) (param i32) (result i32) (call $compute (local.get 0))) ) / {:ok, pid} = Wasmtime.load(%Wasmtime.FromBytes{ bytes: mod, func_imports: [ {fn x -&gt; &quot;Hello from Elixir! Got \#{x}. Returning an i32 value&quot; |&gt; IO.inspect() 20 + x end, [:i32], [:i32]} ] }) {:ok, [200]} = Wasmtime.call_func(pid, &quot;run&quot;, [180])This next example loads a Wasm module from this wasmapp_bg.wasm file that's been built with wasm-pack:{:ok, pid} = Wasmtime.load(%Wasmtime.FromFile{file_path: &quot;test/data/wasmapp/wasmapp_bg.wasm&quot;}) {:ok, {[:i32, :i32], [:i32]}} = Wasmtime.get_func(pid, &quot;add&quot;) {:ok, {[:i32], [:i32]}} = Wasmtime.get_func(pid, &quot;plus_10&quot;) {:ok, {[:i32, :i32], [:i32]}} = Wasmtime.get_func(pid, &quot;min&quot;) {:ok, [20]} = Wasmtime.call_func(pid, &quot;add&quot;, [11, 9]) {:ok, [30]} = Wasmtime.call_func(pid, &quot;plus_10&quot;, [20]) {:ok, [-10]} = Wasmtime.call_func(pid, &quot;min&quot;, [-10, 3])If you want to see more usage examples, check this test file out.","ref":"readme.html#usage","title":"README - Usage","type":"extras"},{"doc":"Functions are supported with the four value types i32, i64, f32 and f64Memory will be supported soonGlobals and Tables are will be considered in the future","ref":"readme.html#supported-wasm-types","title":"README - Supported Wasm types","type":"extras"}]